=== debian/changelog ===
dlt-daemon (2.18.8-6) unstable; urgency=medium

  * Switch from GENIVI to COVESA

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Jan 2023 15:36:58 +0100

dlt-daemon (2.18.8-5) unstable; urgency=medium

  * debian/patches/433.patch
    - Add upstream-proposed patch to fix latomic underlinkage on riscv64
  * Upload to lunar with atomic fix on cmake

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Jan 2023 11:40:57 +0100

dlt-daemon (2.18.8-4) unstable; urgency=medium

  * Enable tests during build
  * Enable extended filtering feature.
  * Refresh patch 398
  * Add upstream patch to fix a test build failure
  * Add R^3: no

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Jan 2023 10:41:43 +0100

dlt-daemon (2.18.8-3) unstable; urgency=medium

  * Fix dh_installinit call with compat level 13
  * Install some more tool and manpage, e.g. dlt-sortbytimestamp
  * Also install cmake helper
  * Install some missing manpages
  * Override dh_install to avoid installing not needed files, avoiding
    dh_missing failures with compat level 13

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Jan 2023 07:20:45 +0100

dlt-daemon (2.18.8-2) unstable; urgency=medium

  * debian/patches/398.patch
    - add upstream patch to fix a buffer overflow on 32 bit systems.
  * Bump std-version to4.6.2
  * Bump compat level to 13

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Jan 2023 15:07:11 +0100

dlt-daemon (2.18.8-1) unstable; urgency=low

  * New upstream release
  * Dropped an upstreamed patch

 -- Aigars Mahinovs <aigarius@debian.org>  Mon, 14 Nov 2022 21:50:12 +0100

dlt-daemon (2.18.6-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * CVE-2022-31291: Double free in dlt_config_file_set_section().
    (Closes: #1014534)

 -- Adrian Bunk <bunk@debian.org>  Thu, 18 Aug 2022 19:39:48 +0300
