## dlt-daemon 2.18.9

=== debian/changelog ===
dlt-daemon (2.18.9-1) unstable; urgency=medium

  * New upstream release.
  * Fix watch file regex to take account of alpha releases
  * Drop all patches, now fixed upstream
  * Add two patches proposed upstream, 481.patch and 482.patch
    to fix build failures with security build flags enabled and with different
    cmake configurations

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Apr 2023 11:26:31 +0200
